/*
 * win_func.c extace source file
 * 
 * /GDK/GNOME sound (esd) system output display program
 * 
 * Copyright (C) 1999 by Dave J. Andruczyk 
 * 
 * Based upon Code written by The Rasterman and DrMike from redhat.com
 * Re-hacked to look good by The Rasterman (Michael Fullbright)
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include <config.h>
#include <globals.h>
#include <protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#include <esd.h>

void window_functions() 
{
    GtkWidget *vbox;
    GtkWidget *hbox;
    GtkWidget *label;
    GtkWidget *scale;
    GtkObject *adj1;
    GSList *group;
    GtkWidget *button;
    if (window_function)
	return;	// <-- its already opened

    window_function = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_set_title(GTK_WINDOW(window_function),"Window Functions");
    gtk_container_border_width(GTK_CONTAINER(window_function),0);
    gtk_signal_connect(GTK_OBJECT(window_function), "delete_event",
		       GTK_SIGNAL_FUNC (close_winfun), NULL);
    hbox = gtk_hbox_new(FALSE,10);
    gtk_container_add(GTK_CONTAINER(window_function), hbox);

    adj1 = gtk_adjustment_new(75.0,0.0,100.0,1.0,1.0,1.0);
    scale = gtk_vscale_new(GTK_ADJUSTMENT(adj1));
    gtk_scale_set_digits(GTK_SCALE(scale),0);
    GTK_ADJUSTMENT (adj1)->value = win_scale*100;
    gtk_box_pack_end(GTK_BOX(hbox),scale,TRUE,TRUE,0);
    gtk_range_set_update_policy(GTK_RANGE (scale),
				GTK_UPDATE_CONTINUOUS);
    gtk_signal_connect (GTK_OBJECT (adj1), "value_changed",
			GTK_SIGNAL_FUNC (slider_changed), (gpointer)WIN_SCALE);
    gtk_signal_connect (GTK_OBJECT (adj1), "value_changed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)window_function);
    gtk_widget_show(scale);

    vbox = gtk_vbox_new(FALSE,10);
    gtk_container_add(GTK_CONTAINER(hbox), vbox);

    button = gtk_radio_button_new_with_label(NULL,"Hamming");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == HAMMING)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)HAMMING);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Hanning");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == HANNING)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)HANNING);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Blackman");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == BLACKMAN)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)BLACKMAN);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Gaussian");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == GAUSSIAN)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)GAUSSIAN);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Welch");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == WELCH)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)WELCH);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Parzen");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == PARZEN)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)PARZEN);

    group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
    button = gtk_radio_button_new_with_label(group,"Rectangular");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    if(window_func == RECTANGULAR)
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (button), TRUE);
    gtk_signal_connect (GTK_OBJECT (button), "pressed",
			GTK_SIGNAL_FUNC (setup_datawindow), (gpointer)RECTANGULAR);

    gtk_widget_show_all(window_function);

}

void setup_datawindow(GtkWidget *widget, WindowFunction function)
{
    gint i=0;
    gdouble sumw=0.0;
    gdouble *ptr;
#ifdef WINDOW_DEBUG
    FILE *f;
#endif
    gint fftlen = nsamp/2; 
    gint alpha = 1;

#ifdef WINDOW_DEBUG
    f = fopen("/tmp/window.in", "w");
    fprintf(f, "I\twin_val\t\twin_sum\n");
#endif
    if (datawindow == NULL)
    {
	datawindow = g_malloc0(nsamp*sizeof(double));
    }
    ptr = datawindow;
    switch(function)
    {
	case RECTANGULAR:
	    for (i=0;i/fftlen/2;i++)
		*ptr++ = 1.0;
	    break;
	default:
	    for (i=0;i/fftlen/2;i++)
		*ptr++ = 0.0;
    }

    for(i=0;i<fftlen;i++)
    {
	switch(function)
	{
	    case HAMMING:   /* Hamming */
		*ptr = (0.54-0.46*cos(2*M_PI*i/(fftlen-1)));
		break;
	    case HANNING:    /* Hanning */
		*ptr = (0.5 - 0.5*cos(2*M_PI*i/(fftlen-1)));
		break;

	    case BLACKMAN:    /* Blackman */
		*ptr = (0.42 - 0.5*cos((2*M_PI*i)/(fftlen-1))+0.08*cos((2*M_PI*i)/(fftlen-1)));
		break;

	    case GAUSSIAN:    /* Gaussian */
		*ptr = (exp(-alpha / ((double)fftlen*(double)fftlen)
			    * ((double)2*i-fftlen)*((double)2*i-fftlen)));
		break;
	    case WELCH:    /* Welch */
		*ptr = (1 -  ((double)(2*i-fftlen)/(double)(fftlen+1))
			    * ((double)(2*i-fftlen)/(double)(fftlen+1)));
		break;
		
	    case PARZEN:    /* Parzen */
		*ptr = (1 - fabs((double)(2*i-fftlen)/(double)(fftlen+1)));
		break;

	    case RECTANGULAR:    /* Rectangular */
		*ptr = 1.0;
		break;

	    default:   /* Hamming */
		*ptr = (0.54-0.46*cos(2*M_PI*i/(fftlen-1)));
		break;
	}
	sumw += *ptr;

#ifdef WINDOW_DEBUG
	fprintf(f, "%i\t%f\t%f\n", i, *ptr, sumw);
#endif
	ptr++;
	
    }
    switch(function)
    {
	case RECTANGULAR:
	    for (i=0;i/fftlen/2;i++)
		*ptr++ = 1.0;
	    break;
	default:
	    for (i=0;i/fftlen/2;i++)
		*ptr++ = 0.0;
    }
#ifdef WINDOW_DEBUG
    fclose(f);
#endif

#ifdef WINDOW_DEBUG
    fprintf(stderr, "window sum is %f\n",sumw);
#endif
    datawindowsum = sumw;
    window_func = function;
}

gint close_winfun(GtkWidget *widget, gpointer data)
{
    gtk_widget_destroy(widget);
    window_function = NULL;
    return TRUE;
}
